var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  FlexProvider: () => FlexProvider,
  FlexintialConfiguration: () => FlexintialConfiguration,
  htboxSelector: () => htboxSelector,
  initialvalue: () => initialvalue,
  useFlexService: () => useFlexService
});
module.exports = __toCommonJS(src_exports);

// src/flexstore/FlexMachine.js
var import_toolkit = require("@reduxjs/toolkit");
var FlexintialConfiguration = [{
  data: {},
  storageType: "local"
}];
var initialvalue = (data) => {
  return (data || []).map((item) => ({ ...item }));
};
var resultObject = initialvalue(FlexintialConfiguration).reduce(
  (accumulator, currentObject) => {
    return { ...accumulator, ...currentObject };
  },
  {}
);
var saveStateToStorage = (state, storageType) => {
  switch (storageType) {
    case "local":
      localStorage.setItem("FlexState", JSON.stringify(state));
      break;
    case "session":
      sessionStorage.setItem("FlexState", JSON.stringify(state));
      break;
    default:
      break;
  }
};
var storedState = JSON.parse(localStorage.getItem("FlexState")) || JSON.parse(sessionStorage.getItem("FlexState"));
if (!storedState) {
  saveStateToStorage(resultObject, FlexintialConfiguration.storageType);
}
var initialState = storedState || resultObject;
var reducers = {};
for (let key in initialState) {
  const setKey = `${key.charAt(0).toUpperCase() + key.slice(1)}`;
  reducers[setKey] = (state, action) => {
    state[key] = action.payload;
    saveStateToStorage(state, FlexintialConfiguration[0].storageType);
  };
}
var iqSlice = (0, import_toolkit.createSlice)({
  name: "iqSlice",
  initialState,
  reducers
});
var htboxSelector = iqSlice.actions;
var FlexMachine_default = iqSlice.reducer;

// src/flexstore/flexService.js
var import_react_redux = require("react-redux");
var import_axios = __toESM(require("axios"));
var useFlexService = () => {
  const dispatch = (0, import_react_redux.useDispatch)();
  const iqSliceState = (0, import_react_redux.useSelector)((state) => state.iqSlice);
  function FlexSender(storeName, args) {
    const dispatchHandler = htboxSelector["Data"];
    try {
      return dispatch(dispatchHandler({ ...iqSliceState.data, [storeName]: args }));
    } catch (error) {
      console.error("An error occurred while dispatching the action:", error);
    }
  }
  function FlexDetector(args) {
    return iqSliceState.data[args];
  }
  async function FlexApi({
    method,
    url,
    payload: data = null,
    contentType = "application/json",
    onUploadProgress = null,
    onDownloadProgress = null,
    flexstore
  }) {
    try {
      let loadingStatus = "Loading...";
      let loadedPercentage = 0;
      const config = {
        headers: {
          "Content-Type": contentType
        },
        onUploadProgress,
        // Pass the provided onUploadProgress callback
        onDownloadProgress
        // Pass the provided onDownloadProgress callback
      };
      let response;
      if (method === "GET") {
        if (data) {
          response = await import_axios.default.get(url, { ...config, data });
        } else {
          response = await import_axios.default.get(url, config);
        }
      } else if (method === "POST") {
        response = await import_axios.default.post(url, data, config);
      } else if (method === "PUT") {
        response = await import_axios.default.put(url, data, config);
      } else if (method === "DELETE") {
        response = await import_axios.default.delete(url, config);
      }
      loadingStatus = "Loading completed.";
      if (flexstore == null ? void 0 : flexstore.storeaccess) {
        FlexSender(flexstore == null ? void 0 : flexstore.statename, response.data);
      }
      return {
        data: response.data,
        loadingStatus,
        loadedPercentage,
        status: response.status
      };
    } catch (error) {
      console.error("Error:", error.message);
      return {
        data: null,
        loadingStatus: "Error occurred.",
        loadedPercentage: 0,
        error: error.message,
        status: error.response ? error.response.status : 500
      };
    }
  }
  return {
    FlexSender,
    FlexDetector,
    FlexApi
  };
};

// src/flexstore/FlexConfig.jsx
var import_react = __toESM(require("react"));
var import_react_redux2 = require("react-redux");
var import_toolkit2 = require("@reduxjs/toolkit");
var FlexStore = (0, import_toolkit2.configureStore)({
  reducer: {
    iqSlice: FlexMachine_default
    // Add other reducers here if needed
  }
});
var FlexProvider = (props) => {
  const { element } = props;
  return /* @__PURE__ */ import_react.default.createElement(import_react_redux2.Provider, { store: FlexStore }, element);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  FlexProvider,
  FlexintialConfiguration,
  htboxSelector,
  initialvalue,
  useFlexService
});
